#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void
writeProgramBin(  size_t binary_size, char *binary,
                  char *filename )
{
    FILE *output = NULL;
    fprintf( stderr,"Writing out binary kernel to %s\n", filename );
    output = fopen( filename, "wb" );
    fwrite( binary, sizeof(char), binary_size, output );
    if( output == NULL )
	{
	  fprintf( stderr, "Unable to open %s for write. Exiting.\n",
                   filename );
          exit( -1 );
        }
    fclose( output );
}


int main( int argc, char *argv[])
{
    unsigned int i = 0,j=0;
    FILE * input = NULL;
    size_t size1 = 0;
    size_t size2 = 0;
    size_t size3 = 0;
    size_t size4 = 0;
    unsigned char * binary1 = NULL;
    unsigned char * binary2 = NULL;
    unsigned char * binary3 = NULL;
    unsigned char * binary4 = NULL;
    char *filename;
    int ctr1=0;
    int ctr2=0;
    int ctr3=0;
    int ctr4=0;
    int ctr5=0;
    int ctr6=0;
    int ctr=0 ;
    int store1[500] ;
    int store2[500] ;
    size_t size;
   
    if ( argc != 2 ) {printf("Error:modBinIL:Too few arguments\n"); return 1; }
     else filename = argv[1] ;
	
        
    
	fprintf( stderr,"Reading in binary kernel from %s\n", filename );
        input = fopen( filename, "rb" );
        if( input == NULL )
        {
            fprintf( stderr, "Unable to open %s for reading.\n", filename );
            
        }
        fseek( input, 0L, SEEK_END );    
        size1 = ftell( input );
        rewind( input );
        binary1 = (char *)malloc( size1 );
        fread( binary1, sizeof(char), size1, input );
        fclose( input );
	
		
	int isaInitFileA, isaEndFileA;
	
	for(i=0;i<size1;i++)
	{
	  
	  if(binary1[i+3] == 0xC0)
	    if(binary1[i+2] == 0x88)
	      if(binary1[i+1] == 0x01)
		if(binary1[i] == 0x04){
		  isaInitFileA = i;
		  break;
		}
	 
	}
	
	for(i=0;i<size1;i++)
	{
	  
	  if(binary1[i+3] == 0x36)
	    if(binary1[i+2] == 0x36)
	      if(binary1[i+1] == 0x4E)
		if(binary1[i] == 0xFF)
		  isaEndFileA = i;
	
	 
	}
	
	
	
	fprintf(stdout,"%d",isaInitFileA);
	
	if((isaEndFileA-isaInitFileA)!=4168) {
	fprintf(stderr,"Warning:ISA bytecode length mismatch.\n");
	fprintf(stdout," %d",(isaEndFileA-isaInitFileA)) ;
	  
	}
	fprintf(stdout,"\n");
	
	return 0;

}


 
